//*************************************************
// USART 12F
//
// Library for EUSART usage on PIC12F1822/40
// author: Bernardo Giovanni
// http://www.settorezero.com
// date:  12/10/11
//
// PLEASE DON'T REDISTRIBUTE WITHOUT PERMISSION
//
// E' VIETATA LA RIPUBBLICAZIONE SU ALTRI SITI,
// FORUM O ALTRI MEZZI SENZA AUTORIZZAZIONE
// DELL'AUTORE
//
// Prerequisites:
// you must define _XTAL_FREQ macro in the main, expressed as Hz
// ex.: 
// #define _XTAL_FREQ 32000000 // 32MHz
//
// WARNING!
// this library use SYNC=0, BRGH=1 and BRG16=0, so the SPBRG value
// is calculated for those settings. If you want to use different settings
// you must change the SPBRGVAL formula define
//*************************************************

// comment this define if you want TX on RA0, leave uncommented for RA4
#define USE_TX_ALT 
// comment this define if you want RX on RA1, leave uncommented for RA5
#define USE_RX_ALT
// baudrate
#define BAUDRATE 57600


// don't edit below this line
// ------------------------------------------------------------------------------------
#ifndef USE_TX_ALT
#define TX_PIN TRISA0
#define TXS	0
#define TXM	0xFE
#else
#define TX_PIN TRISA4
#define TXS	1
#define TXM	0xEF
#endif

#ifndef USE_RX_ALT
#define RX_PIN TRISA1
#define RXS	0
#define RXM 0xFD
#else
#define RX_PIN TRISA5
#define RXS	1
#define RXM	0xDF // doesn't exists on 12F
#endif

// with	SYNC=0 , BRG16=0 , BGRH=1
// baudrate is: FOSC/[16 (n+1)] where n= SPBRGH:SPBRGL
#define SPBRGVAL (int)(((long)_XTAL_FREQ-(long)BAUDRATE)/(16*(long)BAUDRATE))

extern void uart_init(void);	
extern void putch(unsigned char);
extern unsigned char getch(void);
extern unsigned char getche(void);
